          #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F10'             ; 
                                     
            
Sec           equ         20h               ;    
Sec1          equ         21h               ; 
Sec2          equ         22h               ;   
scetbit       equ         23h               ;       spi
dat_ind       equ         24h               ;       spi
adr_ind       equ         25h               ;       spi
dat_tmp       equ         26h               ;       spi
adr_tmp       equ         27h               ;       spi
shet          equ         28h               ;  
data_1        equ         29h               ;       

#DEFINE       din         PORTB,5           ;    MAX7219
#DEFINE       cs          PORTB,6           ;   MAX7219
#DEFINE       clk         PORTB,7           ;   MAX7219

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                            
Start         movlw       b'01000000'       ;    B
              movwf       PORTB
              
              movlw       b'00000111'       ; 
              movwf       CMCON

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00011111'       ;  \  B  
              movwf       TRISB             ;RB0-RB4  ,   
              bcf         STATUS,RP0        ; 0-                 
              
              call        init_lcd          ;   (MAX7219) 
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  8-    ,     'R'  
;         
                                            
met_1         movlw       data_1            ;      
              movwf       FSR               ; 
              movlw       b'01111000'       ; 1-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000100'       ; 2-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000100'       ; 3-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01111000'       ; 4-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01010000'       ; 5-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01001000'       ; 6-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000100'       ; 7-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00000000'       ; 8-    
              movwf       INDF              ;
                                            ;
              call        vivod             ;                       
              call        paus_2s           ;   2 
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  8-    ,     'L'  
;         
                                            
              movlw       data_1            ;      
              movwf       FSR               ; 
              movlw       b'01000000'       ; 1-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000000'       ; 2-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000000'       ; 3-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000000'       ; 4-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000000'       ; 5-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000100'       ; 6-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01111100'       ; 7-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00000000'       ; 8-    
              movwf       INDF              ;
                                            ;
              call        vivod             ;                       
              call        paus_2s           ;   2 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  8-    ,     15  
;         
                                            
              movlw       data_1            ;      
              movwf       FSR               ; 
              movlw       b'00101111'       ; 1-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01101000'       ; 2-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10101000'       ; 3-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00101111'       ; 4-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00100001'       ; 5-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00100001'       ; 6-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00101111'       ; 7-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00000000'       ; 8-    
              movwf       INDF              ;
                                            ;
              call        vivod             ;                       
              call        paus_2s           ;   2 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  8-    ,     1  
;         
                                            
              movlw       data_1            ;      
              movwf       FSR               ; 
              movlw       b'00111100'       ; 1-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000010'       ; 2-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10111101'       ; 3-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10100101'       ; 4-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10100101'       ; 5-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10111101'       ; 6-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000010'       ; 7-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00111100'       ; 8-    
              movwf       INDF              ;
                                            ;
              call        vivod             ;                       
              call        paus_2s           ;   2 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  8-    ,     2  
;         
                                            
              movlw       data_1            ;      
              movwf       FSR               ; 
              movlw       b'11100111'       ; 1-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'11000011'       ; 2-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10100101'       ; 3-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00011000'       ; 4-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00011000'       ; 5-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10100101'       ; 6-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'11000011'       ; 7-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'11100111'       ; 8-    
              movwf       INDF              ;
                                            ;
              call        vivod             ;                       
              call        paus_2s           ;   2 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  8-    ,     3  
;         
                                            
              movlw       data_1            ;      
              movwf       FSR               ; 
              movlw       b'10011001'       ; 1-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000010'       ; 2-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00100100'       ; 3-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10100101'       ; 4-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10100101'       ; 5-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'00100100'       ; 6-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'01000010'       ; 7-    
              movwf       INDF              ;
              incf        FSR,F             ;  FSR
              movlw       b'10011001'       ; 8-    
              movwf       INDF              ;
                                            ;
              call        vivod             ;                       
              call        paus_2s           ;   2 
              goto        met_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  8-        MAX7219

vivod         movlw       .8                ;  
              movwf       shet              ;
              movlw       data_1            ;      
              movwf       FSR               ;
              movlw       .1                ;       MAX7219    
              movwf       adr_ind           ;  adr_ind
viv_1         movf        INDF,W            ;      
              movwf       dat_ind           ; (dat_ind)     MAX7219
              call        send              ;      
              incf        FSR,F             ;  FSR
              incf        adr_ind,F         ;  adr_ind
              decfsz      shet,F            ;  
              goto        viv_1             ;   :    viv_1 
              return                        ;  :   
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  (MAX7219)

init_lcd      call        pauslcd           ;   2 
              movlw       0x0F              ;  
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0C              ;    
              movwf       adr_ind           ;
              movlw       0x01              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0A              ;   31/32
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x09              ;    
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0B              ; 8 
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  2-  ( )   (MAX7219)   SPI

send          bcf         cs                ;    CS
              movlw      .8                 ;    adr_ind  
              movwf      scetbit            ;
              movf       adr_ind,W          ;      
              movwf      adr_tmp            ;
povtor        bcf        clk                ;
              btfsc      adr_tmp,7          ;
              bsf        din                ;
              btfss      adr_tmp,7          ;
              bcf        din                ;
              bsf        clk                ;
              rlf        adr_tmp,F          ;
              decfsz     scetbit,F          ;
              goto       povtor             ;
             
              movlw      .8                 ;    dat_ind  
              movwf      scetbit            ;
              movf       dat_ind,W          ;      
              movwf      dat_tmp            ;
povtr1        bcf        clk                ;
              btfsc      dat_tmp,7          ;
              bsf        din                ;
              btfss      dat_tmp,7          ;
              bcf        din                ;
              bsf        clk                ;
              rlf        dat_tmp,F          ;
              decfsz     scetbit,F          ;
              goto       povtr1             ;
              bcf        clk                ;
              bsf        cs                 ;  1    CS                 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pauslcd       movlw       .4                ;  2 
              movwf       Sec1              ;
p2            movlw       .166              ;
              movwf       Sec               ;
p1            decfsz      Sec,F             ;
              goto        p1                ;
              decfsz      Sec1,F            ;
              goto        p2                ;
              return                        ;  
                                            
paus_2s       movlw       .10               ;  2 
              movwf       Sec2              ;
p_3           movlw       .255              ;
              movwf       Sec1              ;
p_2           movlw       .255              ;
              movwf       Sec               ;
p_1           decfsz      Sec,F             ;
              goto        p_1               ;
              decfsz      Sec1,F            ;
              goto        p_2               ;
              decfsz      Sec2,F            ;
              goto        p_3               ;
              return                        ;  
                                            
              end                           ;  
                                            ;
